Attribute VB_Name = "Declares"
Option Explicit

' Function declarations

Public Declare Function SendMessage& Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any)
'    Parameter        Type/Description
'      hwnd           Long - Handle of the window to receive the message
'      wMsg           Long - the identifier of the message
'      sParam         Long - Depends on the message
'      lParam         Long - Depends on the message
' Return value   Long - Depends on the message

Public Declare Function GetKeyboardState& Lib "user32" (pbKeyState As Byte)

' Constant definitions
Public Const EM_GETSEL& = &HB0      ' Get selected text SendMessage number
Public Const VK_INSERT& = &H2D      ' Insert virtual key number

Public Function HighWord(dword As Long) As Long

    ' This is the HIWORD of the lParam:
    ' HIWORD = dword \ &H10000 And &HFFFF&
    ' HIWORD now equals 30,583 or &H7777
    
    If dword And &H80000000 Then
        HighWord = (dword \ 65535) - 1
    Else
        HighWord = dword \ 65535
    End If
    
End Function

Public Function LowWord(dword As Long) As Long

    ' This is the LOWORD of the lParam:
    ' LowWord = dword And &HFFFF&
    ' LOWORD now equals 65,535 or &HFFFF
    
    If dword And &H8000& Then
        LowWord = &H8000 Or (dword And &H7FFF&)
    Else
        LowWord = dword And &HFFFF&
    End If
    
End Function

