VERSION 5.00
Begin VB.UserControl MaskedEdit 
   ClientHeight    =   510
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1185
   ScaleHeight     =   34
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   79
   ToolboxBitmap   =   "MaskedEdit.ctx":0000
   Begin VB.TextBox txtMaskedEdit 
      Height          =   510
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1185
   End
End
Attribute VB_Name = "MaskedEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

' Mask characters
Private Const strANY_CHAR         As String * 1 = "*"   ' Any character
Private Const strNUMBER           As String * 1 = "%"   ' Only numbers (0-9 only)
Private Const strNUMERIC          As String * 1 = "#"   ' Numerics (0-9, minus, decimal point)
Private Const strUPPER            As String * 1 = "U"   ' Upper case alpha
Private Const strLOWER            As String * 1 = "L"   ' Lower case alpha
Private Const strLookUp           As String * 1 = "?"   ' Use lookup string
Private Const strLITERAL          As String * 1 = "\"   ' Next character is a literal constant

' Ascii code equivalent for "-" (minus sign)
Private Const intKEYASCII_MINUS   As Integer = 45

' Ascii code equivalent for "." (decimal point)
Private Const intKEYASCII_DECIMAL As Integer = 46

' Ascii code equivalent for " " (space)
Private Const intKEYASCII_SPACE   As Integer = 32

' Default Property Values:
Const m_def_Mask = vbNullString
Const m_def_RawData = vbNullString
Const m_def_LookUpTable = vbNullString
Const m_def_FontTransparent = 0

' Property Variables:
Private m_Mask                          As String
Private m_LookUpTable                   As String
Private mstr_RawData                    As String
Private mlng_ScrollBar                  As Long
Dim m_FontTransparent                   As Boolean

' Current character position
Private Type CharacterPosition
    Start   As Integer
    End     As Integer
End Type

' Current Position in the Text Property
Private udtText     As CharacterPosition
' Current Caret Position in the RawData Property
Private udtRawData  As CharacterPosition

' Event Declarations:
Event Click() 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_UserMemId = -600
Event DblClick() 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Attribute DblClick.VB_UserMemId = -601
Event KeyPress(KeyAscii As Integer) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Attribute KeyPress.VB_UserMemId = -603
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Attribute MouseDown.VB_UserMemId = -605
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Attribute MouseMove.VB_UserMemId = -606
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Attribute MouseUp.VB_UserMemId = -607
Event Change() 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,Change
Attribute Change.VB_Description = "Occurs when the contents of a control have changed."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Attribute KeyDown.VB_UserMemId = -602
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Attribute KeyUp.VB_UserMemId = -604
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize
Event OLECompleteDrag(Effect As Long) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLECompleteDrag
Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLEDragDrop
Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLEDragOver
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLEGiveFeedback
Event OLESetData(Data As DataObject, DataFormat As Integer) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLESetData
Event OLEStartDrag(Data As DataObject, AllowedEffects As Long) 'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLEStartDrag

Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_UserMemId = -552
    frmAbout.Show vbModal
    Unload frmAbout
    Set frmAbout = Nothing
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = txtMaskedEdit.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    txtMaskedEdit.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

Private Function CountMaskDataChars() As Integer

    ' Returns the number of data characters in the mask
    
    Dim intMaskIndex   As Integer    ' Index to loop thru the mask
    Dim strMaskChar    As String     ' Single mask character
    
    For intMaskIndex = 1 To Len(m_Mask)
        ' Get the mask character
        strMaskChar = Mid(m_Mask, intMaskIndex, 1)
        
        ' If this is a data mask character count it
        If strMaskChar = strANY_CHAR Or strMaskChar = strNUMBER Or _
           strMaskChar = strNUMERIC Or strMaskChar = strUPPER Or _
           strMaskChar = strLOWER Or strMaskChar = strLookUp Then
            ' Increment the number of mask data characters counter
            CountMaskDataChars = CountMaskDataChars + 1
        End If
    Next intMaskIndex

End Function

Private Function FormatRawData(ByVal vstrRawdata As String) As String

    ' This function formats the raw data as per the mask
    
    Dim intMaskIdx    As Integer        ' Index to loop thru mask
    Dim intDataIdx    As Integer        ' Index to loop thru string
    Dim strMask       As String         ' Mask character
    Dim strData       As String         ' String character
    Dim intStringLen  As Integer        ' String length
    Dim intKeyAscii   As Integer        ' ASCII code for string character
    Dim intAppliedChar As Integer       ' The Number of applied Rawdata characters
    
    FormatRawData = vbNullString
    
    intStringLen = Len(vstrRawdata)
    intMaskIdx = 1
    intDataIdx = 1
    
    ' Did the develope specify a mask?
    If Len(m_Mask) > 0 Then
    
        Do While intMaskIdx <= Len(m_Mask)
        
            ' Get the corresponding mask character
            strMask = Mid(m_Mask, intMaskIdx, 1)
                    
            If intDataIdx <= intStringLen Then
                strData = Mid(vstrRawdata, intDataIdx, 1)
                intKeyAscii = Asc(Mid(vstrRawdata, intDataIdx, 1))
            Else
                strData = Chr(intKEYASCII_SPACE)
                intKeyAscii = intKEYASCII_SPACE
            End If
            
            Select Case strMask
                Case strANY_CHAR    ' Any character
                    FormatRawData = FormatRawData & strData
                    intDataIdx = intDataIdx + 1     ' Next string character
                Case strNUMBER      ' Only numbers (0-9 only)
                    If (intKeyAscii >= vbKey0 And intKeyAscii <= vbKey9) Or _
                       (intKeyAscii = intKEYASCII_SPACE) Then
                        FormatRawData = FormatRawData & strData
                        intDataIdx = intDataIdx + 1     ' Next string character
                    End If
                    
                Case strNUMERIC     ' Numerics (0-9, minus, decimal point)
                    ' If the key is a number (0-9) or
                    ' the key is "-" or
                    ' the key is "." or
                    ' the key is " " then put it in the output string
                    If (intKeyAscii >= vbKey0 And intKeyAscii <= vbKey9) Or _
                       (intKeyAscii = intKEYASCII_MINUS) Or _
                       (intKeyAscii = intKEYASCII_DECIMAL) Or _
                       (intKeyAscii = intKEYASCII_SPACE) Then
                        FormatRawData = FormatRawData & strData
                        intDataIdx = intDataIdx + 1     ' Next string character
                    End If
                
                Case strUPPER       ' Upper case alpha
                    ' If lower case alpha then convert to upper case alpha
                    If intKeyAscii >= vbKeyA + 32 And intKeyAscii <= vbKeyZ + 32 Then
                        intKeyAscii = intKeyAscii - 32
                        strData = Chr(intKeyAscii)
                    End If
                
                    If (intKeyAscii >= vbKeyA And intKeyAscii <= vbKeyZ) Or _
                       (intKeyAscii = intKEYASCII_SPACE) Then
                        FormatRawData = FormatRawData & strData
                        intDataIdx = intDataIdx + 1     ' Next string character
                    End If
                    
                Case strLOWER       ' Lower case alpha
                    ' Lower case alpha characters are 32 more than their
                    ' equivalent upper case alpha characters.  For example,
                    ' "A" is 65 while "a" is 97 and "Z" is 90 while "z" is 122.
                    
                    ' If upper case alpha then convert to lower case alpha
                    If intKeyAscii >= vbKeyA And intKeyAscii <= vbKeyZ Then
                        intKeyAscii = intKeyAscii + 32
                        strData = Chr(intKeyAscii)
                    End If
                    
                    If (intKeyAscii >= vbKeyA + 32 And _
                        intKeyAscii <= vbKeyZ + 32) Or _
                       (intKeyAscii = intKEYASCII_SPACE) Then
                        FormatRawData = FormatRawData & strData
                        intDataIdx = intDataIdx + 1     ' Next string character
                    End If
                
                Case strLookUp      ' Use lookup string
                    FormatRawData = FormatRawData & strData
                    intDataIdx = intDataIdx + 1     ' Next string character
                    
                Case strLITERAL     ' Next character is a literal constant
                    ' Point to the character past the "\"
                    intMaskIdx = intMaskIdx + 1
                    
                    ' Get that mask character
                    strMask = Mid(m_Mask, intMaskIdx, 1)
                    
                    ' Place that literal character into
                    ' the formattted text string
                    FormatRawData = FormatRawData & strMask
            
                Case Else           ' Any other character
                    ' The mask character is not a data mask.  It must be
                    ' some other constant (such as "(", ")", "-", etc.).
                    ' This character is appended.
                    FormatRawData = FormatRawData & strMask
            End Select
            
            ' Next character in the mask
            intMaskIdx = intMaskIdx + 1
            
        Loop
    Else
        ' No mask specified, take the entire string
        ' No mask specified, was a maximum length specified?
        If txtMaskedEdit.MaxLength > 0 Then
            FormatRawData = Left$(strData, txtMaskedEdit.MaxLength)
        Else
            ' No maximum length specified, put the
            ' entire string into the raw data string
            FormatRawData = vstrRawdata
        End If
        
    End If      ' Was a mask specified?
    
End Function

' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   GetCharacterLocations: Returns the Current Caret Location
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Private Sub GetCharacterLocations()
                                 
    Dim lngReturn       As Long     ' SendMessage return value
    Dim lnghWnd         As Long     ' Handle of window to receive message
    
    Dim strTempStr      As String   ' A temporary copy of the Text property
    Dim lngCurrentPos   As Long     ' The Current Character
    Dim lngRawDataPos   As Long     ' The Position in the RawData
    
    'Public Declare Function SendMessage& Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any)
    '    Parameter        Type/Description
    '      hwnd           Long - Handle of the window to receive the message
    '      wMsg           Long - the identifier of the message
    '      sParam         Long - Depends on the message
    '      lParam         Long - Depends on the message
    ' Return value   Long - Depends on the message
    
    ' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
    '   Get the Caret Position in the Text
    ' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
    
    ' Get a handle to the text box window
    lnghWnd = txtMaskedEdit.hWnd
    
    ' Send a message to get the caret position
    lngReturn = SendMessage(lnghWnd, EM_GETSEL&, 0, 0)
    
    ' Set the Caret position in the private UDT
    udtText.End = lngReturn \ &H10000
    udtText.Start = lngReturn And &H7FFF
    
End Sub

Private Function InsertOn() As Boolean

    Dim bytKeyArray(256) As Byte
    Dim lngReturn        As Long
    Dim intInsert        As Integer
    
    ' Initialize return to insert off.  This implies overwrite.
    InsertOn = False
    
    ' Retrieve the current state of each virtual key on the
    ' keyboard.  Take a snapshot of the entire keyboard
    lngReturn = GetKeyboardState(bytKeyArray(0))
    
    ' Look at the entry for the insert key
    intInsert = bytKeyArray(VK_INSERT)
    
    ' The low bit indicates the state of the toggle
    If intInsert And 1 Then InsertOn = True
    
End Function

Private Function IsALiteral(ByVal vstrCharToCheck As String) As Boolean
    
    ' Returns true if this character is a literal mask character
    
    If vstrCharToCheck <> strANY_CHAR And vstrCharToCheck <> strNUMBER And _
       vstrCharToCheck <> strNUMERIC And vstrCharToCheck <> strUPPER And _
       vstrCharToCheck <> strLOWER And vstrCharToCheck <> strLookUp Then
        IsALiteral = True
    Else
        IsALiteral = False
    End If

End Function

Private Sub MovePastLiterals(vintDirection As Integer)
    
    Dim strMaskChar    As String    ' Single mask character
    Dim blnNotALiteral As Boolean
    Dim intNextCharLoc As Integer
    
    ' If the next character in the mask is a literal (such as
    ' "(", ")", "-", etc.) then position the caret immediately
    ' after it.
    blnNotALiteral = False
    
    ' Look at the next character, for Forward direction search we start
    '   looking at one, for a backward search we start at 0
    '
    '   We start at one for a forward search because the next character
    '   forward is one position ahead of the text.
    '   We start at zero for a backward search because the next character is right
    '   behind us.
    intNextCharLoc = IIf(vintDirection = 1, 1, 0)
    
    ' We don't need to check if we are going backwards and are at the first char
    If vintDirection < 0 And txtMaskedEdit.SelStart = 0 Then Exit Sub
    
    strMaskChar = Mid(m_Mask, txtMaskedEdit.SelStart + (intNextCharLoc * vintDirection), 1)
        
        
    ' If the next character is a literal move the caret
    ' past it so the user can type at the next location
    If IsALiteral(strMaskChar) Then
        ' Move the caret past all consecutive literals
        Do Until blnNotALiteral Or _
                 txtMaskedEdit.SelStart + (intNextCharLoc * vintDirection) >= Len(m_Mask) _
                 Or txtMaskedEdit.SelStart + (intNextCharLoc * vintDirection) = 0
            strMaskChar = Mid(m_Mask, txtMaskedEdit.SelStart + (intNextCharLoc * vintDirection), 1)
            If IsALiteral(strMaskChar) Then
                ' Move to next character to check
                intNextCharLoc = intNextCharLoc + 1
            Else
                blnNotALiteral = True
                ' Since this character is a literal we have to set the caret
                ' before this character
                intNextCharLoc = intNextCharLoc - IIf(vintDirection = 1, 1, 0)
            End If
        Loop
        
        txtMaskedEdit.SelStart = txtMaskedEdit.SelStart + (intNextCharLoc * vintDirection)
        
    End If

End Sub

Private Sub RepositionCaret(ByVal vintKeyAscii As Integer)
    ' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
    '   RepositionCaret      : Positions the caret after the string
    '                          has been reformatted
    '       Parameters:
    '           vintKeyAscii : The last key pressed
    ' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
    Dim intDirection As Integer     ' Direction of the Move Literal Search
    
    intDirection = 1
    If vintKeyAscii = vbKeyBack Then
        intDirection = -1
        ' Since we are going backward we want to decrement the Selstart
        '   providing we are not at the beginning of the line
        If udtText.Start > 0 Then
            txtMaskedEdit.SelStart = udtText.Start - 1
        Else
            txtMaskedEdit.SelStart = 0
        End If
    ElseIf vintKeyAscii = vbKeyDelete Then
        ' If this is the backspace or delete key position
        ' the caret after he character that was deleted
        txtMaskedEdit.SelStart = udtText.Start
    Else
        ' Otherwise, position the cursor at the
        ' next character
        txtMaskedEdit.SelStart = udtText.Start + 1
    End If
    
    Call MovePastLiterals(intDirection)
End Sub

Private Function ValidCharacter(ByRef intKeyAscii As Integer) As Boolean

    ' This subroutine ensures that the key pressed is valid for
    ' the position within the string according to the mask.  It
    ' returns true if valid, otherwise false.
    
    ' The following table lists the edit-type characters and
    ' their meaning:
    '     Edit-Type Character     Meaning
    '     -------------------     -------
    '              *              Any Character
    '              %              0-9 only
    '              #              0-9, minus, decimal point
    '              U              Upper case alpha
    '              L              Lower case alpha
    '              ?              Use lookup string specified by the
    '                             CharacterTable property. If null,
    '                             nothing may be entered
    '              \              Next character is a literal constant
    
    ' Any other character in a mask is considered to be a literal
    ' constant that cannot be edited. All edit-defining characters
    ' except a question mark (?) accept spaces. For example, specifying
    ' numeric entry only in a given position also allows a space to be
    ' entered.
    
    ' Use the backslash (\) to specify one of the mask characters as a
    ' literal constant.
    
    ' This example specifies an upper case letter followed by a fixed
    ' colon, and a field of 6 numeric digits:
    '          CSText1.Mask = "U:%%%%%%"
    '
    ' NOTE: When the Mask property is used the MaxCharacters
    '       property is ignored.
    
    Dim idx             As Integer  ' Index to loop thru new string
    Dim intMaskLen      As Integer  ' Length of the mask
    Dim intNewStringLen As Integer  ' Length of the new string
    Dim intUpperBound   As Integer  ' Upper bound for mask checking
    Dim strChar         As String   ' Single char from new string
    Dim strMask         As String   ' Corresponding mask character
    
    ' If the length of the string + 1 new character is longer
    ' than the mask then the 1 new character is invalid.  No
    ' matter what character it is.  The length of the string
    ' can not exceed the length of the mask.
    intMaskLen = Len(m_Mask)
    
    ' Default to not an invalid character
    ValidCharacter = False
    
    If intKeyAscii = vbKeyBack Or intKeyAscii = vbKeyDelete Then
        ValidCharacter = True
        Exit Function
    End If
    
    If udtText.Start > intMaskLen Then
        ' If the new string length > maximum length then
        ' have exceeded maximum length
        ValidCharacter = False
    Else
        ' Get the Character to work with
        strChar = Chr$(intKeyAscii)
        
        ' Get the corresponding mask character
        strMask = Mid(m_Mask, udtText.Start + 1, 1)
        
        Select Case strMask
            Case strANY_CHAR    ' Any character
                ValidCharacter = True
            Case strNUMBER      ' Only numbers (0-9 only)
                If intKeyAscii >= vbKey0 Or intKeyAscii <= vbKey9 Then
                    ValidCharacter = True
                End If
                
            Case strNUMERIC     ' Numerics (0-9, minus, decimal point)
                ' If the key is not a number (0-9)
                If intKeyAscii >= vbKey0 Or intKeyAscii <= vbKey9 Then
                    ' and the key is not "-" and the key is not "." then
                    If intKeyAscii = intKEYASCII_MINUS And _
                       intKeyAscii = intKEYASCII_DECIMAL Then
                            ' This is an invalid character for the mask
                            ValidCharacter = True
                    End If
                End If
            
            Case strUPPER       ' Upper case alpha
                ' If lower case alpha then convert to upper case alpha
                If intKeyAscii >= vbKeyA + 32 And intKeyAscii <= vbKeyZ + 32 Then
                    intKeyAscii = intKeyAscii - 32
                End If
                
                If intKeyAscii >= vbKeyA And intKeyAscii <= vbKeyZ Then
                    ValidCharacter = True
                End If
                
            Case strLOWER       ' Lower case alpha
                ' Lower case alpha characters are 32 more than their
                ' equivalent upper case alpha characters.  For example,
                ' "A" is 65 while "a" is 97 and "Z" is 90 while "z" is 122.
                
                ' If upper case alpha then convert to lower case alpha
                If intKeyAscii >= vbKeyA And intKeyAscii <= vbKeyZ Then
                    intKeyAscii = intKeyAscii + 32
                End If
                
                If intKeyAscii >= vbKeyA + 32 And intKeyAscii <= vbKeyZ + 32 Then
                    ValidCharacter = True
                End If
                
            Case strLookUp      ' Use lookup string
                ' If this character is not in the look up
                ' table then it is not an invalid character.
                If InLookUpTable(intKeyAscii) Then
                    ValidCharacter = True
                End If
                
            Case strLITERAL     ' Next character is a literal constant
                ' Any character is valid
                ValidCharacter = True
        
            Case Else           ' Any other character
                ' Typed character must equal mask character, otherwise
                ' invalid character
                If strChar <> strMask Then
                    ValidCharacter = False
                End If
        End Select
    End If

End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Appearance"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = txtMaskedEdit.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    txtMaskedEdit.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514
    Enabled = txtMaskedEdit.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    txtMaskedEdit.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont;Font"
Attribute Font.VB_UserMemId = -512
    Set Font = txtMaskedEdit.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set txtMaskedEdit.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,BorderStyle
Public Property Get BorderStyle() As BorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = txtMaskedEdit.BorderStyle
End Property
Public Property Let BorderStyle(New_BorderStyle As BorderStyleConstants)
    ' TODO : Change the BorderStyle
    'txtMaskedEdit.BorderStyle = New_BorderStyle
End Property

Private Function PartialFormatRawData() As String
    ' This function formats the raw data as per the mask and
    ' exits after all of the raw data characters are used
    
    Dim intMaskIdx    As Integer        ' Index to loop thru mask
    Dim intDataIdx    As Integer        ' Index to loop thru string
    Dim strMask       As String         ' Mask character
    Dim strData       As String         ' String character
    Dim intStringLen  As Integer        ' String length
    Dim intKeyAscii   As Integer        ' ASCII code for string character
    Dim intAppliedChar As Integer       ' The Number of applied Rawdata characters
  
    PartialFormatRawData = vbNullString
    
    intStringLen = Len(mstr_RawData)
    intMaskIdx = 1
    intDataIdx = 1
    
    ' Did the develope specify a mask?
    If Len(m_Mask) > 0 Then
    
        Do While intMaskIdx <= Len(m_Mask)
        
            ' Get the corresponding mask character
            strMask = Mid(m_Mask, intMaskIdx, 1)
                    
            If intDataIdx <= intStringLen Then
                strData = Mid(mstr_RawData, intDataIdx, 1)
                intKeyAscii = Asc(Mid(mstr_RawData, intDataIdx, 1))
            End If
            
            Select Case strMask
                Case strANY_CHAR    ' Any character
                    PartialFormatRawData = PartialFormatRawData & strData
                    intDataIdx = intDataIdx + 1     ' Next string character
                    intAppliedChar = intAppliedChar + 1
                Case strNUMBER      ' Only numbers (0-9 only)
                    If (intKeyAscii >= vbKey0 And intKeyAscii <= vbKey9) Or _
                       (intKeyAscii = intKEYASCII_SPACE) Then
                        PartialFormatRawData = PartialFormatRawData & strData
                        intDataIdx = intDataIdx + 1     ' Next string character
                        intAppliedChar = intAppliedChar + 1
                    End If
                    
                Case strNUMERIC     ' Numerics (0-9, minus, decimal point)
                    ' If the key is a number (0-9) or
                    ' the key is "-" or
                    ' the key is "." or
                    ' the key is " " then put it in the output string
                    If (intKeyAscii >= vbKey0 And intKeyAscii <= vbKey9) Or _
                       (intKeyAscii = intKEYASCII_MINUS) Or _
                       (intKeyAscii = intKEYASCII_DECIMAL) Or _
                       (intKeyAscii = intKEYASCII_SPACE) Then
                        PartialFormatRawData = PartialFormatRawData & strData
                        intDataIdx = intDataIdx + 1     ' Next string character
                        intAppliedChar = intAppliedChar + 1
                    End If
                
                Case strUPPER       ' Upper case alpha
                    
                    ' If lower case alpha then convert to upper case alpha
                    If intKeyAscii >= vbKeyA + 32 And intKeyAscii <= vbKeyZ + 32 Then
                        intKeyAscii = intKeyAscii - 32
                        strData = Chr(intKeyAscii)
                    End If
                
                    If (intKeyAscii >= vbKeyA And intKeyAscii <= vbKeyZ) Or _
                       (intKeyAscii = intKEYASCII_SPACE) Then
                        PartialFormatRawData = PartialFormatRawData & strData
                        intDataIdx = intDataIdx + 1     ' Next string character
                        intAppliedChar = intAppliedChar + 1
                    End If
                    
                Case strLOWER       ' Lower case alpha
                    ' Lower case alpha characters are 32 more than their
                    ' equivalent upper case alpha characters.  For example,
                    ' "A" is 65 while "a" is 97 and "Z" is 90 while "z" is 122.
                    
                    ' If upper case alpha then convert to lower case alpha
                    If intKeyAscii >= vbKeyA And intKeyAscii <= vbKeyZ Then
                        intKeyAscii = intKeyAscii + 32
                        strData = Chr(intKeyAscii)
                    End If
                    
                    If (intKeyAscii >= vbKeyA + 32 And _
                        intKeyAscii <= vbKeyZ + 32) Or _
                       (intKeyAscii = intKEYASCII_SPACE) Then
                        PartialFormatRawData = PartialFormatRawData & strData
                        intDataIdx = intDataIdx + 1     ' Next string character
                        intAppliedChar = intAppliedChar + 1
                    End If
                
                Case strLookUp      ' Use lookup string
                    PartialFormatRawData = PartialFormatRawData & strData
                    intDataIdx = intDataIdx + 1     ' Next string character
                    intAppliedChar = intAppliedChar + 1
                    
                Case strLITERAL     ' Next character is a literal constant
                    ' Point to the character past the "\"
                    intMaskIdx = intMaskIdx + 1
                    
                    ' Get that mask character
                    strMask = Mid(m_Mask, intMaskIdx, 1)
                    
                    ' Place that literal character into
                    ' the formattted text string
                    PartialFormatRawData = PartialFormatRawData & strMask
                    
            
                Case Else           ' Any other character
                    ' The mask character is not a data mask.  It must be
                    ' some other constant (such as "(", ")", "-", etc.).
                    ' This character is appended.
                    PartialFormatRawData = PartialFormatRawData & strMask
                    
            End Select
            
            ' Next character in the mask
            intMaskIdx = intMaskIdx + 1
            
            If intAppliedChar = intStringLen Then
                ' We have the Masked string upto what the user typed
                Exit Do
            End If
        Loop
    Else
        ' No mask specified, take the entire string
        ' No mask specified, was a maximum length specified?
        If txtMaskedEdit.MaxLength > 0 Then
            For intDataIdx = 1 To txtMaskedEdit.MaxLength
                strData = Mid(mstr_RawData, intDataIdx, 1)
                PartialFormatRawData = PartialFormatRawData & strData
            Next intDataIdx
        Else
            ' No maximum length specified, put the
            ' entire string into the raw data string
            PartialFormatRawData = mstr_RawData
        End If
        
    End If      ' Was a mask specified?
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    txtMaskedEdit.Refresh
End Sub

Private Sub ShowTemplate()

    ' This subroutine shows a template of what to enter
    
    Dim idx         As Integer
    Dim strMask     As String
    Dim strTemplate As String
    
    ' Initialize the template
    strTemplate = vbNullString
    
    For idx = 1 To Len(m_Mask)
    
        ' Get the mask character
        strMask = Mid(m_Mask, idx, 1)
        
        ' Is the next character a literal?
        If strMask = strLITERAL Then
            ' Move 1 past the literal designator ("\")
            idx = idx + 1
            
            ' Get that character
            strMask = Mid(m_Mask, idx, 1)
            
            ' Put it into the template string
            strTemplate = strTemplate & strMask
        Else
            ' If this is a designator for any character, number,
            ' numeric, upper alpha, lower alpha, or lookup then
            ' put a space place holder
            If strMask = strANY_CHAR Or strMask = strNUMBER Or _
               strMask = strNUMERIC Or strMask = strUPPER Or _
               strMask = strLOWER Or strMask = strLookUp Then
                strTemplate = strTemplate & " "
            Else
                ' Otherwise, put in the typed character
                strTemplate = strTemplate & strMask
            End If
        End If
    Next idx

    ' Show the completed template
    txtMaskedEdit.Text = strTemplate
    mstr_RawData = vbNullString
    
End Sub

Private Function ValidAsciiCharacter(ByVal KeyAscii As Integer) As Boolean

    ' Vaild characters are within the ascii
    ' code range of 32 (space) to 126 ("~")

    If KeyAscii >= 32 And KeyAscii < 127 Then
        ValidAsciiCharacter = True
    Else
        ValidAsciiCharacter = False
    End If

End Function

Private Sub txtMaskedEdit_Click()

    ' If the user clicked past the last character of data then place
    ' the cursor immediately after the last character. Otherwise,
    ' leave the cursor exactly where the user clicked.
    Dim intLastCharPos As Integer
    
    ' Get the position of the cursor
    Call GetCharacterLocations
    
    If Len(m_Mask) > 0 Then
        intLastCharPos = Len(PartialFormatRawData())
    Else
        ' If the user did not specify a mask the
        ' last character position is the last
        ' character of the raw data.  Set the
        ' cursor past that character.
        intLastCharPos = Len(mstr_RawData)
    End If
    
    ' If the user clicked beyond the last character in the string
    ' position the cursor at the last character in the string.
    If intLastCharPos <= udtText.Start Then
        txtMaskedEdit.SelStart = intLastCharPos
    Else
        'udtText.Start = udtText.Start - 1
        Call MovePastLiterals(1)    ' Move in the forward direction
    End If
    
    txtMaskedEdit.SelLength = udtText.End - udtText.Start
    
    RaiseEvent Click
    
End Sub

Private Sub txtMaskedEdit_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub txtMaskedEdit_KeyPress(KeyAscii As Integer)
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    ' Check to see if a mask does not
    ' exist
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    If Len(m_Mask) = 0 Then
        ' No mask, we don't need to process the key, because
        ' we don't have to check for valid characters
        Exit Sub
    End If
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    ' Get the Location of the cursor
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    Call GetCharacterLocations
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    ' Determine the type of character
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    If ValidCharacter(KeyAscii) Then
        Call GetRawDataPosition
        mstr_RawData = ModifyRawData(udtRawData.Start, udtRawData.End, Chr(KeyAscii))
        
        ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
        ' Update the text property
        ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
        txtMaskedEdit.Text = FormatRawData(mstr_RawData)
        
        ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
        ' Reposition the cursor after the
        ' first selected character
        ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
        Call RepositionCaret(KeyAscii)
        txtMaskedEdit.SelLength = 0
        
    End If

    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    ' Send the Event to the user
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    RaiseEvent KeyPress(KeyAscii)
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    ' The key has already been processed.  Cancel the keystroke
    ' so the object does not receive the character again
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    KeyAscii = 0
    
End Sub
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   ModifyRawData : Updates the RawData
'       Parameters:
'           intStart : the Start Location of the insert
'           intEnd   : the End Location of the insertion
'           strChar  : the character to insert it
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Private Function ModifyRawData(ByVal intStart As Integer, _
                               ByVal intEnd As Integer, _
                               ByVal strChar As String) As String
    
    Dim strHolder    As String   ' The string to hold the temporary string
    Dim intTemp      As Integer  ' Number of data characters in the mask
    
    ' Test to see if we just need to append it
    If Len(mstr_RawData) < intStart Then
        ' All we need to do is append the text
        strHolder = mstr_RawData & strChar
        GoTo ModifyRawData_Exit
    Else
        If intStart <> intEnd Then
            ' If the user hit the backspace or delete key
            ' remove those characters from the raw data
            If Asc(strChar) = vbKeyBack Or Asc(strChar) = vbKeyDelete Then
                strHolder = Left$(mstr_RawData, intStart)
            Else
                ' The data needs to be placed inside the string
                strHolder = Left$(mstr_RawData, intStart) & strChar
            End If
            
            ' add the right most portion
            strHolder = strHolder & Mid$(mstr_RawData, intEnd + 1)
        Else
            If Asc(strChar) = vbKeyBack Then
                ' Can't backspace over nothing
                If intStart > 0 Then
                    strHolder = Left$(mstr_RawData, intStart - 1)
                End If
                strHolder = strHolder & Mid$(mstr_RawData, intStart + 1)
            ElseIf Asc(strChar) = vbKeyDelete Then
                strHolder = Left$(mstr_RawData, intStart)
                ' If this is the last character and the user hit
                ' the delete key then don't attempt to add any
                ' characters past the end of the string.
                If intStart + 1 <> Len(mstr_RawData) Then
                    strHolder = strHolder & Mid$(mstr_RawData, intStart + 2)
                End If
            Else
                If InsertOn() Then
                    ' The data needs to be placed inside the string
                    strHolder = Left$(mstr_RawData, intStart) & strChar
                    ' add the right most portion
                    strHolder = strHolder & Mid$(mstr_RawData, intEnd + 1)
                Else
                    strHolder = Left$(mstr_RawData, intStart) & strChar
                    strHolder = strHolder & Mid$(mstr_RawData, intEnd + 2)
                End If
            End If
        End If
    End If
    
' Exit the Function
ModifyRawData_Exit:
    
    If Len(Trim(m_Mask)) > 0 Then
        ' Get number of char's allowed from the mask
        intTemp = CountMaskDataChars
        ModifyRawData = Left$(strHolder, intTemp)
    Else
        If txtMaskedEdit.MaxLength = 0 Then
            ModifyRawData = strHolder
        Else
            ' Ensure that the maxlength is not exceeded
            ModifyRawData = Left$(strHolder, txtMaskedEdit.MaxLength)
        End If
    End If

End Function

Private Sub txtMaskedEdit_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    RaiseEvent MouseDown(Button, Shift, X, Y)

End Sub

Private Sub txtMaskedEdit_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub txtMaskedEdit_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    RaiseEvent MouseUp(Button, Shift, X, Y)
    
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,Appearance
Public Property Get Appearance() As Integer
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
    Appearance = txtMaskedEdit.Appearance
End Property

Private Sub txtMaskedEdit_Change()
   
    RaiseEvent Change
    
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,MaxLength
Public Property Get MaxLength() As Long
Attribute MaxLength.VB_Description = "Returns/sets the maximum number of characters that can be entered in a control."
Attribute MaxLength.VB_ProcData.VB_Invoke_Property = "General;Misc"
    MaxLength = txtMaskedEdit.MaxLength
End Property

Public Property Let MaxLength(ByVal New_MaxLength As Long)
    
    txtMaskedEdit.MaxLength() = New_MaxLength
    PropertyChanged "MaxLength"
    
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,MultiLine
Public Property Get MultiLine() As Boolean
Attribute MultiLine.VB_Description = "Returns/sets a value that determines whether a control can accept multiple lines of text."
    MultiLine = txtMaskedEdit.MultiLine
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,PasswordChar
Public Property Get PasswordChar() As String
Attribute PasswordChar.VB_Description = "Returns/sets a value that determines whether characters typed by a user or placeholder characters are displayed in a control."
Attribute PasswordChar.VB_ProcData.VB_Invoke_Property = "General;Misc"
    PasswordChar = txtMaskedEdit.PasswordChar
End Property

Public Property Let PasswordChar(ByVal New_PasswordChar As String)
    txtMaskedEdit.PasswordChar() = New_PasswordChar
    PropertyChanged "PasswordChar"
End Property


Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    
    txtMaskedEdit.BackColor = PropBag.ReadProperty("BackColor", vbWindowBackground)
    txtMaskedEdit.ForeColor = PropBag.ReadProperty("ForeColor", vbWindowText)
    txtMaskedEdit.Enabled = PropBag.ReadProperty("Enabled", True)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_Mask = PropBag.ReadProperty("Mask", m_def_Mask)
    ' If a mask was specified ignore any MaxLength property.  Set
    ' it to unlimited (zero is unlimited).
    If Len(Trim(m_Mask)) > 0 Then
        txtMaskedEdit.MaxLength = 0
    Else
        txtMaskedEdit.MaxLength = PropBag.ReadProperty("MaxLength", 0)
    End If
    txtMaskedEdit.PasswordChar = PropBag.ReadProperty("PasswordChar", "")
    mstr_RawData = PropBag.ReadProperty("RawData", m_def_RawData)

    Call ShowTemplate
    
    txtMaskedEdit.Text = PropBag.ReadProperty("Text", Extender.Name)
    
    m_LookUpTable = PropBag.ReadProperty("LookUpTable", m_def_LookUpTable)
End Sub

Private Sub UserControl_Resize()

    RaiseEvent Resize
    txtMaskedEdit.Height = ScaleHeight
    txtMaskedEdit.Width = ScaleWidth

End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", txtMaskedEdit.BackColor, vbWindowBackground)
    Call PropBag.WriteProperty("ForeColor", txtMaskedEdit.ForeColor, vbWindowText)
    Call PropBag.WriteProperty("Enabled", txtMaskedEdit.Enabled, True)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("MaxLength", txtMaskedEdit.MaxLength, 0)
    Call PropBag.WriteProperty("PasswordChar", txtMaskedEdit.PasswordChar, "")
    Call PropBag.WriteProperty("Text", txtMaskedEdit.Text, Extender.Name)
    Call PropBag.WriteProperty("Mask", m_Mask, m_def_Mask)
    Call PropBag.WriteProperty("RawData", mstr_RawData, m_def_RawData)
    Call PropBag.WriteProperty("Text", txtMaskedEdit.Text, UserControl.Name)
    Call PropBag.WriteProperty("LookUpTable", m_LookUpTable, m_def_LookUpTable)
    Call PropBag.WriteProperty("FontBold", txtMaskedEdit.FontBold, 0)
    Call PropBag.WriteProperty("FontItalic", txtMaskedEdit.FontItalic, 0)
    Call PropBag.WriteProperty("FontName", txtMaskedEdit.FontName, "")
    Call PropBag.WriteProperty("FontSize", txtMaskedEdit.FontSize, 0)
    Call PropBag.WriteProperty("FontStrikethru", txtMaskedEdit.FontStrikethru, 0)
    Call PropBag.WriteProperty("FontTransparent", m_FontTransparent, m_def_FontTransparent)
    Call PropBag.WriteProperty("FontUnderline", txtMaskedEdit.FontUnderline, 0)
    Call PropBag.WriteProperty("LinkItem", txtMaskedEdit.LinkItem, "")
    Call PropBag.WriteProperty("LinkMode", txtMaskedEdit.LinkMode, 0)
    Call PropBag.WriteProperty("LinkTimeout", txtMaskedEdit.LinkTimeout, 50)
    Call PropBag.WriteProperty("LinkTopic", txtMaskedEdit.LinkTopic, "")
    Call PropBag.WriteProperty("Locked", txtMaskedEdit.Locked, False)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", txtMaskedEdit.MousePointer, 0)
    Call PropBag.WriteProperty("OLEDragMode", txtMaskedEdit.OLEDragMode, 0)
    Call PropBag.WriteProperty("OLEDropMode", txtMaskedEdit.OLEDropMode, 0)
    Call PropBag.WriteProperty("RightToLeft", txtMaskedEdit.RightToLeft, False)
    Call PropBag.WriteProperty("SelLength", txtMaskedEdit.SelLength, 0)
    Call PropBag.WriteProperty("SelStart", txtMaskedEdit.SelStart, 0)
    Call PropBag.WriteProperty("SelText", txtMaskedEdit.SelText, "")
    
End Sub


Public Property Let Mask(ByVal New_Mask As String)
Attribute Mask.VB_Description = "Returns/sets the mask of allowable characters"
Attribute Mask.VB_ProcData.VB_Invoke_PropertyPut = "General;Data"
    m_Mask = New_Mask
    Call ShowTemplate
    PropertyChanged "Mask"
End Property

Public Property Get RawData() As String
Attribute RawData.VB_Description = "Returns/Sets the data without the mask characters"
Attribute RawData.VB_ProcData.VB_Invoke_Property = "General;Data"
Attribute RawData.VB_MemberFlags = "3c"
    RawData = mstr_RawData
End Property

Public Property Let RawData(ByVal New_RawData As String)

    If Len(Trim(New_RawData)) > 0 Then
        mstr_RawData = New_RawData
        txtMaskedEdit.Text = FormatRawData(mstr_RawData)
    End If

    PropertyChanged "RawData"

    
End Property

Private Sub txtMaskedEdit_KeyDown(KeyCode As Integer, Shift As Integer)

    ' Must process the delete key
    If KeyCode = vbKeyDelete Then
        Call GetCharacterLocations
        Call GetRawDataPosition
        mstr_RawData = ModifyRawData(udtRawData.Start, udtRawData.End, Chr(KeyCode))
        txtMaskedEdit.Text = FormatRawData(mstr_RawData)
        Call RepositionCaret(KeyCode)
        KeyCode = 0
    End If
    
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub txtMaskedEdit_KeyUp(KeyCode As Integer, Shift As Integer)
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    ' Check to see if a mask does not
    '   exist
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    If Len(m_Mask) = 0 Then
        ' IF a mask does not exist we have to update
        ' the rawdata property because we did not do it
        ' in the KeyPress Event
        mstr_RawData = txtMaskedEdit.Text
    End If
    
    RaiseEvent KeyUp(KeyCode, Shift)

End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,Text
Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contained in the control."
Attribute Text.VB_ProcData.VB_Invoke_Property = "General;Text"
Attribute Text.VB_UserMemId = -517
Attribute Text.VB_MemberFlags = "200"
    Text = txtMaskedEdit.Text
End Property

Public Property Let Text(ByVal New_Text As String)
    
    If Len(Trim(New_Text)) > 0 Then
        mstr_RawData = GetRawDataFromText(New_Text)
        txtMaskedEdit.Text() = FormatRawData(mstr_RawData)
    End If
    
    PropertyChanged "Text"
    
End Property

Private Function GetRawDataFromText(ByVal vstrNewText As String) As String

    ' This function takes the new text string and removes any mask
    ' characters to obtain the raw data string
    Dim intMaskIndex As Integer     ' Index to loop thru mask
    Dim strMaskChar  As String      ' Single mask character
    
    ' No mask specified take the entire string
    If Len(m_Mask) = 0 Then
        GetRawDataFromText = vstrNewText
    Else
        ' Loop thru the mask 1 character at a time
        For intMaskIndex = 1 To Len(m_Mask)
            ' Get the mask character
            strMaskChar = Mid(m_Mask, intMaskIndex, 1)
            ' Only look at text characters that exist
            If intMaskIndex <= Len(vstrNewText) Then
                ' If this is not a literal mask character,
                ' it is a raw data character
                If Not IsALiteral(strMaskChar) Then
                    GetRawDataFromText = GetRawDataFromText & Mid(vstrNewText, intMaskIndex, 1)
                End If
            End If
        Next intMaskIndex       ' Get next mask character
    End If

End Function

Public Property Get LookUpTable() As String
Attribute LookUpTable.VB_ProcData.VB_Invoke_Property = "General;Data"
    LookUpTable = m_LookUpTable
End Property

Public Property Let LookUpTable(ByVal New_LookUpTable As String)

    ' Index to loop thru user specified lookup string
    Dim idx          As Integer

    ' Program built lookup string w/o duplicate characters
    Dim strNewLookUp As String

    ' Look up character
    Dim strLookupChar As String

    ' Initialize the new look up string
    strNewLookUp = vbNullString

    ' Did the user specify a lookup table?
    If Len(New_LookUpTable) > 0 Then

        ' Loop thru the user specified look up string
        For idx = 1 To Len(New_LookUpTable)

            strLookupChar = Mid(New_LookUpTable, idx, 1)

            ' Is this a valid look up character?
            If ValidAsciiCharacter(Asc(strLookupChar)) Then

                ' Does this character already exist in the look up string?
                If InStr(strNewLookUp, strLookupChar) = 0 Then

                    ' No, concatenate it to the look up string
                    strNewLookUp = strNewLookUp & strLookupChar
                End If
            End If
        Next idx
    End If

    ' Set the member property
    m_LookUpTable = strNewLookUp

    PropertyChanged "LookUpTable"

End Property

Private Sub UserControl_InitProperties()
    ' Initialize Properties for User Control
    m_LookUpTable = m_def_LookUpTable
    txtMaskedEdit.Text = Extender.Name
    mstr_RawData = Extender.Name
    m_FontTransparent = m_def_FontTransparent
    m_Mask = m_def_Mask
    m_LookUpTable = m_def_LookUpTable
End Sub


Private Function MaskCharIsALiteral(ByVal vintCharPosition As Integer) As Boolean

    ' This function returns true if the character position
    ' specified is a literal within the mask
    
    Dim strMask As String
    
    ' Initialize return value to not a literal
    MaskCharIsALiteral = False
    
    strMask = Mid(m_Mask, vintCharPosition, 1)
    ' If the mask character is not any character,
    ' numbers (0-9 only), numerics (0-9, minus, decimal point),
    ' upper case alpha, lower case alpha, use lookup string,
    ' next character is a literal constant ("\") then this
    ' character is a fixed literal constant (such as "-", "(",
    ' ")", etc.)
    If strMask <> strANY_CHAR And strMask <> strNUMBER And _
       strMask <> strNUMERIC And strMask <> strUPPER And _
       strMask <> strLOWER And strMask <> strLookUp And _
       strMask <> strLITERAL Then
        MaskCharIsALiteral = True
    End If
    
End Function

Private Function InLookUpTable(ByVal vintKeyAscii As Integer) As Boolean

    ' This function returns true if the specified ascii
    ' character is in the look-up table, otherwise, false
    
    ' Initialize return to not in look up table
    InLookUpTable = False
    
    ' Did the developer specify a look up table?
    If Len(m_LookUpTable) > 0 Then
    
        ' The developer specified a look up table,
        ' is this character in the look up table?
        
        ' Programmers Note: string1 = string being searched
        '                   string2 = string being sought
        If InStr(m_LookUpTable, Chr(vintKeyAscii)) > 0 Then
        
            ' The character is in the look up table
            InLookUpTable = True
        End If
    End If
    
End Function

Private Sub GetRawDataPosition()

    ' This subroutine maps the current caret start
    ' and end position within the text string into
    ' start and end position within the raw data
    
    Dim intMaskIndex   As Integer    ' Current position within mask
    Dim strMaskChar    As String     ' Single mask character
    Dim strTextChar    As String     ' Single text string character
    Dim intNumElements As Integer
    
    ' Initialize the starting and ending character position
    ' of the cursor within the raw data string
    udtRawData.Start = 0
    udtRawData.End = 0
    intNumElements = 0
    
    ' If a mask is specified then loop thru the mask
    ' 1 char at a time and match the corresponding
    ' text character with the mask.
    If Len(m_Mask) > 0 Then
        For intMaskIndex = 1 To Len(m_Mask)
            strMaskChar = Mid(m_Mask, intMaskIndex, 1)
            
            ' If the mask character is the literal indicator ("\") then
            ' the text character is a literal.  It is not part of the raw
            ' data, so skip it.
            If strMaskChar <> strLITERAL Then
                ' If the mask character is any character, only numbers (0-9 only),
                ' numerics (0-9, minus, decimal point), upper case alpha,
                ' lower case alpha, lookup string, or literal constant, then
                ' append the character to the raw data string
                If strMaskChar = strANY_CHAR Or strMaskChar = strNUMBER Or _
                   strMaskChar = strNUMERIC Or strMaskChar = strUPPER Or _
                   strMaskChar = strLOWER Or strMaskChar = strLookUp Or _
                   strMaskChar = strLITERAL Then
                    
                    ' For each character that is placed into the raw data string
                    ' before the cursor in the masked string increment the cursor
                    ' position within the raw data string.  At the end it will
                    ' contain the cursor position within the raw data string.
                    Select Case intMaskIndex
                        Case Is < udtText.Start
                            udtRawData.Start = udtRawData.Start + 1
                        Case Is = udtText.Start
                            udtRawData.Start = udtRawData.Start + 1
                        Case Is > udtText.Start
                            ' Count the number of actual data elements until
                            ' the end of the selected string.  Add this value
                            ' to the starting postion to get the ending position.
                            If intMaskIndex < udtText.End Then
                                ' Already have processed the 1st starting character
                                ' So, initialize the number of elements counter and
                                ' then increment it for the second character that
                                ' is being processed now.
                                If intNumElements = 0 Then
                                    intNumElements = 1
                                End If
                                
                                intNumElements = intNumElements + 1
                                
                            End If
                    End Select
                    
                End If          ' Is this a mask char that contains data?
            End If              ' Is this a literal ("\")?
            
        Next intMaskIndex       ' Next mask character
        
        ' Add the number of actual data elements until the end
        ' of the selected string to get the ending position.
        udtRawData.End = intNumElements + udtRawData.Start
        
    Else
        ' No mask specified, was a maximum length specified?
        If txtMaskedEdit.MaxLength > 0 Then
            ' Maximum length specified, only put that number of
            ' characters into the raw data string
            udtRawData.Start = 1
            For intMaskIndex = 1 To txtMaskedEdit.MaxLength
                
                ' For each character that is placed into the raw data string
                ' before the cursor in the masked string increment the cursor
                ' position within the raw data string.  At the end it will
                ' contain the cursor position within the raw data string.
                If intMaskIndex <= udtText.Start Then
                    udtRawData.Start = udtRawData.Start + 1
                
                Else
                    ' Count the number of actual data elements until
                    ' the end of the selected string.
                    If intMaskIndex <= udtText.End Then
                        udtRawData.End = udtRawData.End + 1
                    End If
                End If
            Next intMaskIndex
            
        Else
            ' No maximum length or mask specified.  The raw data
            ' starting position is the first character
            ' and the ending position is the last character
            udtRawData.Start = udtText.Start
            udtRawData.End = udtText.End
        End If
        
    End If
    
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,ScrollBars
Public Property Get ScrollBars() As ScrollBarConstants
    ScrollBars = mlng_ScrollBar
End Property

Public Property Let ScrollBars(ByVal New_ScrollBars As ScrollBarConstants)
    mlng_ScrollBar = New_ScrollBars
    ' Send message to Windows to turn on that type of scroll bar
End Property

Public Property Get Mask() As String
    Mask = m_Mask
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,FontBold
Public Property Get FontBold() As Boolean
Attribute FontBold.VB_Description = "Returns/sets bold font styles."
Attribute FontBold.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute FontBold.VB_MemberFlags = "400"
    FontBold = txtMaskedEdit.FontBold
End Property

Public Property Let FontBold(ByVal New_FontBold As Boolean)
    txtMaskedEdit.FontBold() = New_FontBold
    PropertyChanged "FontBold"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,FontItalic
Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_Description = "Returns/sets italic font styles."
Attribute FontItalic.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute FontItalic.VB_MemberFlags = "400"
    FontItalic = txtMaskedEdit.FontItalic
End Property

Public Property Let FontItalic(ByVal New_FontItalic As Boolean)
    txtMaskedEdit.FontItalic() = New_FontItalic
    PropertyChanged "FontItalic"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,FontName
Public Property Get FontName() As String
Attribute FontName.VB_Description = "Specifies the name of the font that appears in each row for the given level."
Attribute FontName.VB_ProcData.VB_Invoke_Property = ";f"
Attribute FontName.VB_MemberFlags = "400"
    FontName = txtMaskedEdit.FontName
End Property

Public Property Let FontName(ByVal New_FontName As String)
    txtMaskedEdit.FontName() = New_FontName
    PropertyChanged "FontName"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,FontSize
Public Property Get FontSize() As Single
Attribute FontSize.VB_Description = "Specifies the size (in points) of the font that appears in each row for the given level."
Attribute FontSize.VB_ProcData.VB_Invoke_Property = ";f"
Attribute FontSize.VB_MemberFlags = "400"
    FontSize = txtMaskedEdit.FontSize
End Property

Public Property Let FontSize(ByVal New_FontSize As Single)
    txtMaskedEdit.FontSize() = New_FontSize
    PropertyChanged "FontSize"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,FontStrikethru
Public Property Get FontStrikethru() As Boolean
Attribute FontStrikethru.VB_Description = "Returns/sets strikethrough font styles."
Attribute FontStrikethru.VB_ProcData.VB_Invoke_Property = ";f"
Attribute FontStrikethru.VB_MemberFlags = "400"
    FontStrikethru = txtMaskedEdit.FontStrikethru
End Property

Public Property Let FontStrikethru(ByVal New_FontStrikethru As Boolean)
    txtMaskedEdit.FontStrikethru() = New_FontStrikethru
    PropertyChanged "FontStrikethru"
End Property

Public Property Get FontTransparent() As Boolean
Attribute FontTransparent.VB_Description = "Returns/sets a value that determines whether background text/graphics on a Form, Printer or PictureBox are displayed."
Attribute FontTransparent.VB_ProcData.VB_Invoke_Property = ";f"
Attribute FontTransparent.VB_MemberFlags = "400"
    FontTransparent = m_FontTransparent
End Property

Public Property Let FontTransparent(ByVal New_FontTransparent As Boolean)
    m_FontTransparent = New_FontTransparent
    PropertyChanged "FontTransparent"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,FontUnderline
Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_Description = "Returns/sets underline font styles."
Attribute FontUnderline.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute FontUnderline.VB_MemberFlags = "400"
    FontUnderline = txtMaskedEdit.FontUnderline
End Property

Public Property Let FontUnderline(ByVal New_FontUnderline As Boolean)
    txtMaskedEdit.FontUnderline() = New_FontUnderline
    PropertyChanged "FontUnderline"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,LinkExecute
Public Sub LinkExecute(Command As String)
Attribute LinkExecute.VB_Description = "Sends a command string to the source application in a DDE conversation."
    txtMaskedEdit.LinkExecute Command
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,LinkItem
Public Property Get LinkItem() As String
Attribute LinkItem.VB_Description = "Returns/sets the data passed to a destination control in a DDE conversation with another application."
Attribute LinkItem.VB_ProcData.VB_Invoke_Property = ";DDE"
    LinkItem = txtMaskedEdit.LinkItem
End Property

Public Property Let LinkItem(ByVal New_LinkItem As String)
    txtMaskedEdit.LinkItem() = New_LinkItem
    PropertyChanged "LinkItem"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,LinkMode
Public Property Get LinkMode() As LinkModeConstants
Attribute LinkMode.VB_Description = "Returns/sets the type of link used for a DDE conversation and activates the connection."
Attribute LinkMode.VB_ProcData.VB_Invoke_Property = ";DDE"
    LinkMode = txtMaskedEdit.LinkMode
End Property

Public Property Let LinkMode(ByVal New_LinkMode As LinkModeConstants)
    txtMaskedEdit.LinkMode() = New_LinkMode
    PropertyChanged "LinkMode"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,LinkPoke
Public Sub LinkPoke()
Attribute LinkPoke.VB_Description = "Transfers contents of Label, PictureBox, or TextBox to source application in DDE conversation."
    txtMaskedEdit.LinkPoke
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,LinkRequest
Public Sub LinkRequest()
Attribute LinkRequest.VB_Description = "Asks the source DDE application to update the contents of a Label, PictureBox, or Textbox control."
    txtMaskedEdit.LinkRequest
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,LinkSend
Public Sub LinkSend()
Attribute LinkSend.VB_Description = "Transfers contents of PictureBox to destination application in DDE conversation."
    txtMaskedEdit.LinkSend
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,LinkTimeout
Public Property Get LinkTimeout() As Integer
Attribute LinkTimeout.VB_Description = "Returns/sets the amount of time a control waits for a response to a DDE message."
    LinkTimeout = txtMaskedEdit.LinkTimeout
End Property

Public Property Let LinkTimeout(ByVal New_LinkTimeout As Integer)
    txtMaskedEdit.LinkTimeout() = New_LinkTimeout
    PropertyChanged "LinkTimeout"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,LinkTopic
Public Property Get LinkTopic() As String
Attribute LinkTopic.VB_Description = "Returns/sets the source application and topic for a destination control."
Attribute LinkTopic.VB_ProcData.VB_Invoke_Property = ";DDE"
    LinkTopic = txtMaskedEdit.LinkTopic
End Property

Public Property Let LinkTopic(ByVal New_LinkTopic As String)
    txtMaskedEdit.LinkTopic() = New_LinkTopic
    PropertyChanged "LinkTopic"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,Locked
Public Property Get Locked() As Boolean
Attribute Locked.VB_Description = "Determines whether a control can be edited."
Attribute Locked.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Locked = txtMaskedEdit.Locked
End Property

Public Property Let Locked(ByVal New_Locked As Boolean)
    txtMaskedEdit.Locked() = New_Locked
    PropertyChanged "Locked"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    Set MouseIcon = txtMaskedEdit.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set txtMaskedEdit.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,MousePointer
Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = txtMaskedEdit.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    txtMaskedEdit.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

Private Sub txtMaskedEdit_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLEDrag
Public Sub OLEDrag()
Attribute OLEDrag.VB_Description = "Starts an OLE drag/drop event with the given control as the source."
    txtMaskedEdit.OLEDrag
End Sub

Private Sub txtMaskedEdit_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLEDragMode
Public Property Get OLEDragMode() As OLEDragConstants
Attribute OLEDragMode.VB_Description = "Returns/Sets whether this object can act as an OLE drag/drop source, and whether this process is started automatically or under programmatic control."
    OLEDragMode = txtMaskedEdit.OLEDragMode
End Property

Public Property Let OLEDragMode(ByVal New_OLEDragMode As OLEDragConstants)
    txtMaskedEdit.OLEDragMode() = New_OLEDragMode
    PropertyChanged "OLEDragMode"
End Property

Private Sub txtMaskedEdit_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,OLEDropMode
Public Property Get OLEDropMode() As OLEDropConstants
Attribute OLEDropMode.VB_Description = "Returns/Sets whether this object can act as an OLE drop target, and whether this takes place automatically or under programmatic control."
    OLEDropMode = txtMaskedEdit.OLEDropMode
End Property

Public Property Let OLEDropMode(ByVal New_OLEDropMode As OLEDropConstants)
    txtMaskedEdit.OLEDropMode() = New_OLEDropMode
    PropertyChanged "OLEDropMode"
End Property

Private Sub txtMaskedEdit_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub

Private Sub txtMaskedEdit_OLESetData(Data As DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub

Private Sub txtMaskedEdit_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,RightToLeft
Public Property Get RightToLeft() As Boolean
Attribute RightToLeft.VB_Description = "Determines text display direction and control visual appearance on a bidirectional system."
Attribute RightToLeft.VB_UserMemId = -611
    RightToLeft = txtMaskedEdit.RightToLeft
End Property

Public Property Let RightToLeft(ByVal New_RightToLeft As Boolean)
    txtMaskedEdit.RightToLeft() = New_RightToLeft
    PropertyChanged "RightToLeft"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,SelLength
Public Property Get SelLength() As Long
Attribute SelLength.VB_Description = "Returns/sets the number of characters selected."
Attribute SelLength.VB_MemberFlags = "400"
    SelLength = txtMaskedEdit.SelLength
End Property

Public Property Let SelLength(ByVal New_SelLength As Long)
    txtMaskedEdit.SelLength() = New_SelLength
    PropertyChanged "SelLength"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,SelStart
Public Property Get SelStart() As Long
Attribute SelStart.VB_Description = "Returns/sets the starting point of text selected."
Attribute SelStart.VB_MemberFlags = "400"
    SelStart = txtMaskedEdit.SelStart
End Property

Public Property Let SelStart(ByVal New_SelStart As Long)
    txtMaskedEdit.SelStart() = New_SelStart
    PropertyChanged "SelStart"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtMaskedEdit,txtMaskedEdit,-1,SelText
Public Property Get SelText() As String
Attribute SelText.VB_Description = "Returns/sets the string containing the currently selected text."
Attribute SelText.VB_MemberFlags = "400"
    SelText = txtMaskedEdit.SelText
End Property

Public Property Let SelText(ByVal New_SelText As String)
    txtMaskedEdit.SelText() = New_SelText
    PropertyChanged "SelText"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,TextHeight
Public Function TextHeight(Str As String) As Single
Attribute TextHeight.VB_Description = "Returns the height of a text string as it would be printed in the current font."
    TextHeight = UserControl.TextHeight(Str)
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,TextWidth
Public Function TextWidth(Str As String) As Single
Attribute TextWidth.VB_Description = "Returns the width of a text string as it would be printed in the current font."
    TextWidth = UserControl.TextWidth(Str)
End Function
